/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void ButtonCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmPushButtonCallbackStruct *cb = (XmPushButtonCallbackStruct *)call_data;
             /* VVVVVV switch by the callback reason */
    switch (cb->reason) {
    case XmCR_ARM:
        printf("Button is pressed.\n"); break;
    case XmCR_DISARM:
        printf("Button is released.\n"); break;
    case XmCR_ACTIVATE:
        printf("Button is clicked.\n"); break;
    }
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  toplevel, rowcol, button;
    Arg     al[20];
    int     ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Callbackreas", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    rowcol = XmCreateRowColumn(toplevel, "rowcol", al, ac);
    XtManageChild(rowcol);

    ac = 0;
    button = XmCreatePushButton(rowcol, "button", al, ac);
    XtManageChild(button);
    /* Register callback funcs for each callback resource */
    XtAddCallback(button, XmNarmCallback, ButtonCB, NULL);
    XtAddCallback(button, XmNdisarmCallback, ButtonCB, NULL);
    XtAddCallback(button, XmNactivateCallback, ButtonCB, NULL);
                          /* AAAAAAAAAA Callback resource */
    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
