/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

extern char **CopyArgv();

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app;
    Display *dpy1, *dpy2;
    Widget  top1, rowcol1, button1, text1;
    Widget  top2, rowcol2, button2, text2;
    Arg     al[20];
    int     ac;
    int     argc2;
    char  **argv2;

    argv2 = CopyArgv(argc, argv); /* Copy the argc and argv */
    if (argv2 == NULL) argc2 = 0;    /* If copy fails, reset to 0 */
    else               argc2 = argc; /* If copy succeeds, copy the argc */

    XtToolkitInitialize(); /* Initialize by separate functions */
    app = XtCreateApplicationContext();
    XtSetLanguageProc(NULL, NULL, NULL);

    /* Open the DISPLAY (Class name is "Dpy1") */
    dpy1 = XtOpenDisplay(app, NULL, NULL, "Dpy1", NULL, 0, &argc, argv);

    /* Create widget tree on the DISPLAY */
    ac = 0;
    top1 = XtAppCreateShell(NULL, "Dpy1", applicationShellWidgetClass,
                            dpy1, al, ac);
    ac = 0;
    rowcol1 = XmCreateRowColumn(top1, "rowcol1", al, ac);
    XtManageChild(rowcol1);
    ac = 0;
    button1 = XmCreatePushButton(rowcol1, "button1", al, ac);
    XtManageChild(button1);

    /* Open the DISPLAY2 (Class name is "Dpy2") */
    dpy2 = XtOpenDisplay(app, getenv("DISPLAY2"),
                         NULL, "Dpy2", NULL, 0, &argc2, argv2);

    /* Create widget tree on the DISPLAY2 */
    ac = 0;
    top2 = XtAppCreateShell(NULL, "Dpy2", applicationShellWidgetClass,
                            dpy2, al, ac);
    ac = 0;
    rowcol2 = XmCreateRowColumn(top2, "rowcol2", al, ac);
    XtManageChild(rowcol2);
    ac = 0;
    button2 = XmCreatePushButton(rowcol2, "button2", al, ac);
    XtManageChild(button2);

    XtRealizeWidget(top1); /* Realize both toplevel shells */
    XtRealizeWidget(top2);

    XtAppMainLoop(app);  /* One event loop is enough */
}
